AWSTemplateFormatVersion: '2010-09-09'
Parameters:
  EnvironmentName:
    Description: The name of the environnment
    Type: String
    AllowedValues:
      - dev
      - qa
      - prod
  Namespace:
    Type: String
    Description: The kubernetes namespace where the service account lives
  ServiceAccountName:
    Type: String
    Description: The name of the kubernetes service account that will assume the PodRole
Resources:
  PodRole:
    Type: AWS::IAM::Role
    Properties:
      AssumeRolePolicyDocument:
        Version: '2012-10-17'
        Statement:
        - Action:
          - 'sts:AssumeRoleWithWebIdentity'
          Effect: Allow
          Principal:
            Federated: !Sub arn:aws:iam::${AWS::AccountId}:oidc-provider/__OIDC_PROVIDER__
          Condition:
            StringEquals:
              __OIDC_PROVIDER__:sub: !Join
                - ':'
                - - system:serviceaccount
                  - !Ref Namespace
                  - !Ref ServiceAccountName

Outputs:
  # Not using an export because this value doesn't seem to rise to the level that would need it
  # To find this value, we can describe the stack
  RoleArn:
    Value: !GetAtt PodRole.Arn
